//
//  ViewController.m
//  运动轨迹TEST
//
//  Created by Super on 16/5/18.
//  Copyright © 2016年 Super. All rights reserved.
//

#import "ViewController.h"
#import <MapKit/MapKit.h>
#import <CoreLocation/CoreLocation.h>
#import <AFNetworking.h>


@interface ViewController ()<MKMapViewDelegate,CLLocationManagerDelegate>

@property (nonatomic, strong) MKMapView *mapView;

@property (nonatomic, strong) CLGeocoder *geocoder;

@property (nonatomic, strong) MKPolyline *routeLine;

@property (nonatomic, strong) NSMutableArray *mutArray;


@end

@implementation ViewController

- (NSMutableArray *)mutArray {
    if (_mutArray == nil) {
        _mutArray = [NSMutableArray array];
    }
    return _mutArray;
}

- (CLGeocoder *)geocoder {
    if (!_geocoder) {
        self.geocoder = [[CLGeocoder alloc] init];
    }
    return _geocoder;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    self.mapView = [[MKMapView alloc] initWithFrame:CGRectMake(0, 0, 375, 667)];
    
    [self.view addSubview:self.mapView];
    
    self.mapView.delegate = self;
    
    
    NSString *url = @"http://bamai188.com:8001/api/gps/";
    
    AFHTTPSessionManager *manager = [AFHTTPSessionManager manager];
    
    NSMutableDictionary *dict = [NSMutableDictionary dictionary];
    dict[@"device_num"] = @"863137002486187";
    dict[@"start_date"] = @"2016-1-1";
    dict[@"end_date"] = @"2016-6-1";
    dict[@"limit"] = @"50";

    
    [manager GET:url parameters:dict success:^(NSURLSessionDataTask * _Nonnull task, id  _Nonnull responseObject) {
        
        
        NSLog(@"%@",responseObject);
        if ([[NSString stringWithFormat:@"%@",responseObject[@"status"]] isEqualToString:@"1"] ) {
            
            NSArray *array = responseObject[@"data"];
            
            NSMutableArray *mutArray = [NSMutableArray array];
            
            for (int i = 0; i < array.count; i++) {
                NSString *latitude = array[i][@"latitude"];
                
                NSString *longitude = array[i][@"longitude"];
                
                CLLocation *location = [[CLLocation alloc] initWithLatitude:[latitude doubleValue] longitude:[longitude doubleValue]];
                
                [mutArray addObject:location];
               
            }
            _mutArray = mutArray;
            
            [self drawLine];
            
            
        } else {
            
            NSLog(@"失败");
        }
        
        
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
    }];
    
    
}

//地图定位
- (void)drawLine {
    CLLocation *location = self.mutArray[0];
    
    MKCoordinateRegion region;
    region.span = MKCoordinateSpanMake(0.005, 0.005);
    region.center = CLLocationCoordinate2DMake(location.coordinate.latitude,location.coordinate.longitude);
    [self.mapView setRegion:region animated:YES];
    
    [self drawLineWithLocationArray:self.mutArray];
}


- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id<MKAnnotation>)annotation
{
    MKPinAnnotationView *annotationView = [[MKPinAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:@"MapSample"];
    
    annotationView.canShowCallout = YES;
    
    return annotationView;
}

//地图画线
- (void)drawLineWithLocationArray:(NSMutableArray *)locationArray
{
    MKMapPoint* pointArray = malloc(sizeof(CLLocationCoordinate2D) * locationArray.count);
    
    for(int idx = 0; idx < locationArray.count; idx++)
    {
        CLLocation *location = [locationArray objectAtIndex:idx];
       
        CLLocationDegrees latitude  = location.coordinate.latitude;
       
        CLLocationDegrees longitude = location.coordinate.longitude;
        
        CLLocationCoordinate2D coordinate = CLLocationCoordinate2DMake(latitude, longitude);
        
        MKMapPoint point = MKMapPointForCoordinate(coordinate);
        
        pointArray[idx] = point;
    }
    
    if (_routeLine) {
        [_mapView removeOverlay:_routeLine];
    }
    
    _routeLine = [MKPolyline polylineWithPoints:pointArray count:locationArray.count];
    
    if (nil != _routeLine) {
        [_mapView addOverlay:_routeLine];
    }
    
    free(pointArray);
}

//减小内存
- (void)mapView:(MKMapView *)mapView regionDidChangeAnimated:(BOOL)animated {
    [self.mapView removeFromSuperview];
    
    [self.view addSubview:mapView];
}

//地图线属性
- (MKOverlayRenderer *)mapView:(MKMapView *)mapView rendererForOverlay:(id<MKOverlay>)overlay {
    
    MKPolylineRenderer *renderer = [[MKPolylineRenderer alloc] initWithOverlay:overlay];
    
    renderer.strokeColor = [UIColor blueColor];
    
    renderer.lineWidth = 5;
    
    return renderer;
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
